//+-------------------------------------------------------------------+
//| Pivot_PerDay.mq4                                                  |
//| Copyright  2004, MetaQuotes Software Corp.                       |
//| http://www.metaquotes.net                                         |
//|                                                                   |
//| Modified by Hossein Paydar                                        |
//|                                                                   |
//| You are free to use it                                            |
//|                                                                   |
//|                                                                   |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern bool pivots = true;
extern bool camarilla = true;
extern bool midpivots = true;
extern int  HowManyWeekAgo=1;

double thisWeek_high=0;
double thisWeek_low=0;
double prevWeek_high=0;
double prevWeek_open=0;
double prevWeek_low=0;
double prevWeek_close=0;
double thisWeek_open=0;
double P=0;
double Q=0;
double R1,R2,R3;
double M0,M1,M2,M3,M4,M5;
double S1,S2,S3;
double H4,H3,L4,L3;
double nQ=0;
double nD=0;
double D=0;
double rates_W1[2][6];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
 R1=0; R2=0; R3=0;
 M0=0; M1=0; M2=0; M3=0; M4=0; M5=0;
 S1=0; S2=0; S3=0;
 H4=0; H3=0; L4=0; L3=0;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
ObjectDelete("wR1 Label"); 
ObjectDelete("wR1 Line");
ObjectDelete("wR2 Label");
ObjectDelete("wR2 Line");
ObjectDelete("wR3 Label");
ObjectDelete("wR3 Line");
ObjectDelete("wS1 Label");
ObjectDelete("wS1 Line");
ObjectDelete("wS2 Label");
ObjectDelete("wS2 Line");
ObjectDelete("wS3 Label");
ObjectDelete("wS3 Line");
ObjectDelete("wP Label");
ObjectDelete("wP Line");
ObjectDelete("wH4 Label");
ObjectDelete("wH4 Line");
ObjectDelete("wH3 Label");
ObjectDelete("wH3 Line");
ObjectDelete("wL3 Label");
ObjectDelete("wL3 Line");
ObjectDelete("wL4 Label");
ObjectDelete("wL4 Line");
ObjectDelete("wM5 Label");
ObjectDelete("wM5 Line");
ObjectDelete("wM4 Label");
ObjectDelete("wM4 Line");
ObjectDelete("wM3 Label");
ObjectDelete("wM3 Line");
ObjectDelete("wM2 Label");
ObjectDelete("wM2 Line");
ObjectDelete("wM1 Label");
ObjectDelete("wM1 Line");
ObjectDelete("wM0 Label");
ObjectDelete("wM0 Line");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---- TODO: add your code here

//---- exit if period is greater than daily charts
/////if(Period() > 1440)
/////{
/////Print("Error - Chart period is greater than 1 day.");
/////return(-1); // then exit
/////}

//---- Get new daily prices

ArrayCopyRates(rates_W1, Symbol(), PERIOD_W1);

Print("prevWeek_open = ",rates_W1[HowManyWeekAgo][1]);
Print("prevWeek_low  = ",rates_W1[HowManyWeekAgo][2]);
Print("prevWeek_high = ",rates_W1[HowManyWeekAgo][3]);
Print("prevWeek_close= ",rates_W1[HowManyWeekAgo][4]);

prevWeek_close = rates_W1[HowManyWeekAgo][4];
prevWeek_open = rates_W1[HowManyWeekAgo][1];
thisWeek_open = rates_W1[HowManyWeekAgo-1][1];
prevWeek_high = rates_W1[HowManyWeekAgo][3];
prevWeek_low = rates_W1[HowManyWeekAgo][2];
thisWeek_high = rates_W1[HowManyWeekAgo-1][3];
thisWeek_low = rates_W1[HowManyWeekAgo-1][2];


//---- Calculate Pivots
D = (thisWeek_high - thisWeek_low);
Q = (prevWeek_high - prevWeek_low);
P = (prevWeek_high + prevWeek_low + prevWeek_close) / 3;
R1 = (2*P)-prevWeek_low;
S1 = (2*P)-prevWeek_high;
R2 = P+(prevWeek_high - prevWeek_low);
S2 = P-(prevWeek_high - prevWeek_low);
H4 = (Q*0.55)+prevWeek_close;
H3 = (Q*0.27)+prevWeek_close;
R3 = (2*P)+(prevWeek_high-(2*prevWeek_low));
M5 = (R2+R3)/2;
M4 = (R1+R2)/2;
M3 = (P+R1)/2;
M2 = (P+S1)/2;
M1 = (S1+S2)/2;
S3 = (2*P)-((2* prevWeek_high)-prevWeek_low);
L3 = prevWeek_close-(Q*0.27);	
L4 = prevWeek_close-(Q*0.55);	
M0 = (S2+S3)/2;

//---- Set line labels on chart window

//---- Pivot Lines
   if (pivots==true)
   {
      if(ObjectFind("wR1 label") != 0)
      {
      ObjectCreate("wR1 label", OBJ_TEXT, 0, Time[20], R1);
      ObjectSetText("wR1 label", " wR1", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wR1 label", 0, Time[20], R1);
      }

      if(ObjectFind("wR2 label") != 0)
      {
      ObjectCreate("wR2 label", OBJ_TEXT, 0, Time[20], R2);
      ObjectSetText("wR2 label", " wR2", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wR2 label", 0, Time[20], R2);
      }

      if(ObjectFind("wR3 label") != 0)
      {
      ObjectCreate("wR3 label", OBJ_TEXT, 0, Time[20], R3);
      ObjectSetText("wR3 label", " wR3", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wR3 label", 0, Time[20], R3);
      }

      if(ObjectFind("wP label") != 0)
      {
      ObjectCreate("wP label", OBJ_TEXT, 0, Time[20], P);
      ObjectSetText("wP label", "wPivot", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wP label", 0, Time[20], P);
      }

      if(ObjectFind("wS1 label") != 0)
      {
      ObjectCreate("wS1 label", OBJ_TEXT, 0, Time[20], S1);
      ObjectSetText("wS1 label", "wS1", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wS1 label", 0, Time[20], S1);
      }

      if(ObjectFind("wS2 label") != 0)
      {
      ObjectCreate("wS2 label", OBJ_TEXT, 0, Time[20], S2);
      ObjectSetText("wS2 label", "wS2", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wS2 label", 0, Time[20], S2);
      }

      if(ObjectFind("wS3 label") != 0)
      {
      ObjectCreate("wS3 label", OBJ_TEXT, 0, Time[20], S3);
      ObjectSetText("wS3 label", "wS3", 8, "Arial", White);
      }
      else
      {
      ObjectMove("wS3 label", 0, Time[20], S3);
      }

//---  Draw  Pivot lines on chart
      if(ObjectFind("wS1 line") != 0)
      {
      ObjectCreate("wS1 line", OBJ_HLINE, 0, Time[40], S1);
      ObjectSet("wS1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("wS1 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("wS1 line", 0, Time[40], S1);
      }

      if(ObjectFind("wS2 line") != 0)
      {
      ObjectCreate("wS2 line", OBJ_HLINE, 0, Time[40], S2);
      ObjectSet("wS2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("wS2 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("wS2 line", 0, Time[40], S2);
      }

      if(ObjectFind("wS3 line") != 0)
      {
      ObjectCreate("wS3 line", OBJ_HLINE, 0, Time[40], S3);
      ObjectSet("wS3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("wS3 line", OBJPROP_COLOR, Red);
      }
      else
      {
      ObjectMove("wS3 line", 0, Time[40], S3);
      }

      if(ObjectFind("WP line") != 0)
      {
      ObjectCreate("WP line", OBJ_HLINE, 0, Time[40], P);
      ObjectSet("WP line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WP line", OBJPROP_COLOR, Magenta);
      }
      else
      {
      ObjectMove("WP line", 0, Time[40], P);
      }

      if(ObjectFind("WR1 line") != 0)
      {
      ObjectCreate("WR1 line", OBJ_HLINE, 0, Time[40], R1);
      ObjectSet("WR1 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WR1 line", OBJPROP_COLOR, LimeGreen);
      }
      else
      {
      ObjectMove("WR1 line", 0, Time[40], R1);
      }

      if(ObjectFind("WR2 line") != 0)
      {
      ObjectCreate("WR2 line", OBJ_HLINE, 0, Time[40], R2);
      ObjectSet("WR2 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WR2 line", OBJPROP_COLOR, LimeGreen);
      }
      else
      {
      ObjectMove("WR2 line", 0, Time[40], R2);
      }

      if(ObjectFind("WR3 line") != 0)
      {
      ObjectCreate("WR3 line", OBJ_HLINE, 0, Time[40], R3);
      ObjectSet("WR3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("WR3 line", OBJPROP_COLOR, LimeGreen);
      }
      else
      {
      ObjectMove("WR3 line", 0, Time[40], R3);
      }
   }
//---- End of Pivot Line Draw 


//----- Camarilla Lines

   if (camarilla==true)
   {
      if(ObjectFind("WH4 label") != 0)
      {
      ObjectCreate("WH4 label", OBJ_TEXT, 0, Time[20], H4);
      ObjectSetText("WH4 label", " WH4", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WH4 label", 0, Time[20], H4);
      }

      if(ObjectFind("WH3 label") != 0)
      {
      ObjectCreate("WH3 label", OBJ_TEXT, 0, Time[20], H3);
      ObjectSetText("WH3 label", " WH3", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WH3 label", 0, Time[20], H3);
      }

      if(ObjectFind("WL3 label") != 0)
      {
      ObjectCreate("WL3 label", OBJ_TEXT, 0, Time[20], L3);
      ObjectSetText("WL3 label", " WL3", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WL3 label", 0, Time[20], L3);
      }

      if(ObjectFind("WL4 label") != 0)
      {
      ObjectCreate("WL4 label", OBJ_TEXT, 0, Time[20], L4);
      ObjectSetText("WL4 label", " WL4", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WL4 label", 0, Time[20], L4);
      }

//---- Draw Camarilla lines on Chart
      if(ObjectFind("WH4 line") != 0)
      {
      ObjectCreate("WH4 line", OBJ_HLINE, 0, Time[40], H4);
      ObjectSet("WH4 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WH4 line", OBJPROP_COLOR, Yellow);
      }
      else
      {
      ObjectMove("WH4 line", 0, Time[40], H4);
      }

      if(ObjectFind("WH3 line") != 0)
      {
      ObjectCreate("WH3 line", OBJ_HLINE, 0, Time[40], H3);
      ObjectSet("WH3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WH3 line", OBJPROP_COLOR, Yellow);
      }
      else
      {
      ObjectMove("WH3 line", 0, Time[40], H3);
      }

      if(ObjectFind("WL3 line") != 0)
      {
      ObjectCreate("WL3 line", OBJ_HLINE, 0, Time[40], L3);
      ObjectSet("WL3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WL3 line", OBJPROP_COLOR, Yellow);
      }
      else
      {
      ObjectMove("WL3 line", 0, Time[40], L3);
      }

      if(ObjectFind("WL4 line") != 0)
      {
      ObjectCreate("WL4 line", OBJ_HLINE, 0, Time[40], L4);
      ObjectSet("WL4 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WL4 line", OBJPROP_COLOR, Yellow);
      }
      else
      {
      ObjectMove("WL4 line", 0, Time[40], L4);
      }
   }
//-------End of Draw Camarilla Lines

//------ Midpoints Pivots 

   if (midpivots==true)
   {

      if(ObjectFind("WM5 label") != 0)
      {
      ObjectCreate("WM5 label", OBJ_TEXT, 0, Time[20], M5);
      ObjectSetText("WM5 label", " WM5", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WM5 label", 0, Time[20], M5);
      }

      if(ObjectFind("WM4 label") != 0)
      {
      ObjectCreate("WM4 label", OBJ_TEXT, 0, Time[20], M4);
      ObjectSetText("WM4 label", " WM4", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WM4 label", 0, Time[20], M4);
      }

      if(ObjectFind("WM3 label") != 0)
      {
      ObjectCreate("WM3 label", OBJ_TEXT, 0, Time[20], M3);
      ObjectSetText("WM3 label", " WM3", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WM3 label", 0, Time[20], M3);
      }

      if(ObjectFind("WM2 label") != 0)
      {
      ObjectCreate("WM2 label", OBJ_TEXT, 0, Time[20], M2);
      ObjectSetText("WM2 label", " WM2", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WM2 label", 0, Time[20], M2);
      }

      if(ObjectFind("WM1 label") != 0)
      {
      ObjectCreate("WM1 label", OBJ_TEXT, 0, Time[20], M1);
      ObjectSetText("WM1 label", " WM1", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WM1 label", 0, Time[20], M1);
      }

      if(ObjectFind("WM0 label") != 0)
      {
      ObjectCreate("WM0 label", OBJ_TEXT, 0, Time[20], M0);
      ObjectSetText("WM0 label", " WM0", 8, "Arial", White);
      }
      else
      {
      ObjectMove("WM0 label", 0, Time[20], M0);
      }
      
//---- Draw Midpoint Pivots on Chart
      if(ObjectFind("WM5 line") != 0)
      {
      ObjectCreate("WM5 line", OBJ_HLINE, 0, Time[40], M5);
      ObjectSet("WM5 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WM5 line", OBJPROP_COLOR, Blue);
      }
      else
      {
      ObjectMove("WM5 line", 0, Time[40], M5);
      }

      if(ObjectFind("WM4 line") != 0)
      {
      ObjectCreate("WM4 line", OBJ_HLINE, 0, Time[40], M4);
      ObjectSet("WM4 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WM4 line", OBJPROP_COLOR, Blue);
      }
      else
      {
      ObjectMove("WM4 line", 0, Time[40], M4);
      }

      if(ObjectFind("WM3 line") != 0)
      {
      ObjectCreate("WM3 line", OBJ_HLINE, 0, Time[40], M3);
      ObjectSet("WM3 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WM3 line", OBJPROP_COLOR, Blue);
      }
      else
      {
      ObjectMove("WM3 line", 0, Time[40], M3);
      }

      if(ObjectFind("WM2 line") != 0)
      {
      ObjectCreate("WM2 line", OBJ_HLINE, 0, Time[40], M2);
      ObjectSet("WM2 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WM2 line", OBJPROP_COLOR, Blue);
      }
      else
      {
      ObjectMove("WM2 line", 0, Time[40], M2);
      }

      if(ObjectFind("WM1 line") != 0)
      {
      ObjectCreate("WM1 line", OBJ_HLINE, 0, Time[40], M1);
      ObjectSet("WM1 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WM1 line", OBJPROP_COLOR, Blue);
      }
      else
      {
      ObjectMove("WM1 line", 0, Time[40], M1);
      }

      if(ObjectFind("WM0 line") != 0)
      {
      ObjectCreate("WM0 line", OBJ_HLINE, 0, Time[40], M0);
      ObjectSet("WM0 line", OBJPROP_STYLE, STYLE_DASHDOTDOT);
      ObjectSet("WM0 line", OBJPROP_COLOR, Blue);
      }
      else
      {
      ObjectMove("WM0 line", 0, Time[40], M0);
      }

   }
//----End of Midpoint Pivots Draw
 
//---- End Of Program
   return(0);
  }
//+------------------------------------------------------------------+